#!/usr/bin/env python2.2

##redhat-logviewer - preferences dialog box
##
## Copyright (C) 2001, 2002 Red Hat, Inc.
## Copyright (C) 2001, 2002 Tammy Fox <tfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#Originally Written by Tammy Fox
#Created December 12, 2001
#Last Modified May 15, 2002

## Coding conventions
## function names have underscores (_)
## variable names are semiStudlyCapped
## class names are StudlyCapped
## class instances are semiStudlyCapped

from gtk import *
import string
import gtk
import signal
import gobject
import os
import time
import LogViewerGui
import LogFileClass

##
## I18N
## 
import gettext
gettext.bindtextdomain ("redhat-logviewer", "/usr/share/locale")
gettext.textdomain ("redhat-logviewer")
_=gettext.gettext

##---------------------------------------------------------------

##---------------------------------------------------------------
##---------------------------------------------------------------

##
## Main Class
##

class Preferences:

## Init

    def __init__ (self):
        self.preferences = gtk.Dialog(_("Preferences"))
	self.preferences.set_size_request(450, 400)
	self.preferences.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
	self.preferences.set_border_width(2)
	self.preferences.set_modal(gtk.TRUE)
        self.preferences.set_position(gtk.WIN_POS_CENTER_ON_PARENT)

        self.preferences.set_icon(LogViewerGui.iconPixbuf)

	#--------Preferences Notebook-------------------------------
 	self.prefsNotebook = gtk.Notebook()
 	self.prefsNotebook.set_show_tabs(gtk.TRUE)		
 	self.preferences.vbox.pack_start(self.prefsNotebook, gtk.TRUE, gtk.TRUE)
	
	#--------Log Files and Refresh Rate page----------------------
        self.logFilesVBox = gtk.VBox(gtk.FALSE, 6)
        self.logFilesFrame = gtk.Frame(_("Log Files"))
        self.logFilesFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.logFilesFrame.set_border_width(6)        

        self.lFdescriptionHBox = gtk.HBox(gtk.FALSE, 6)
        self.lFdescriptionHBox.set_border_width(2)

        prefsImage = gtk.Image()
        prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 3)

        self.lFdescriptionHBox.pack_start(prefsImage)

        label = gtk.Label(_("Configure the path and filename for each log file displayed."))
        label.set_line_wrap(gtk.TRUE)
        label.set_size_request(250, -1)
        self.lFdescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)

        self.logFilesVBox.pack_start(self.lFdescriptionHBox, gtk.FALSE, gtk.FALSE)

        self.logFilesScrollWindow = gtk.ScrolledWindow()
        self.logFilesScrollWindow.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        self.logFilesScrollWindow.set_shadow_type(gtk.SHADOW_ETCHED_IN)

	self.logFilesTreeView = gtk.TreeView(LogViewerGui.logFilesListStore)
        col = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=0)
        col.set_title(_("Log File"))
        col.set_visible(gtk.TRUE)
        col2 = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=1)
        col2.set_title(_("Location"))
        col2.set_visible(gtk.TRUE)
        self.logFilesTreeView.set_headers_visible(gtk.TRUE)
        self.logFilesTreeView.append_column(col)
        self.logFilesTreeView.append_column(col2)
        self.logFilesTreeView.set_border_width(8)
        selection = self.logFilesTreeView.get_selection()
        selection.connect("changed", self.select_category)

        self.logFilesTreeView.set_rules_hint(gtk.TRUE)

        self.logFilesScrollWindow.add(self.logFilesTreeView)
        self.logFilesVBox.pack_start(self.logFilesScrollWindow, gtk.TRUE, gtk.TRUE)

        self.logFilesFrame.add(self.logFilesVBox)

        #Change Location button
        self.changeButtonHBox = gtk.HBox(gtk.FALSE,3)
        self.changeButton = gtk.Button(_("Change Location"))
        align = gtk.Alignment (1.0, 0.5, 0.0, 0.0)
        align.add(self.changeButton)
        self.changeButton.connect ("clicked", self.on_changed_clicked)
        self.logFilesVBox.pack_start(align, gtk.FALSE, gtk.FALSE)
        self.logFilesVBox.set_border_width(6)

        #Refresh Rate spinner
        self.refreshRateFrame = gtk.Frame(_("Refresh Rate"))
        self.refreshRateFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.refreshRateFrame.set_border_width(6)      
        self.refreshRateLabel = gtk.Label(_("Refresh log file every "))
        self.refreshRateSpin = gtk.SpinButton(gtk.Adjustment(LogViewerGui.RefreshRate/1000,30,600,1,1,0), 0, 0)
        self.refreshRateSecLabel = gtk.Label(_("seconds."))
        self.refreshRateHBox = gtk.HBox(gtk.FALSE,3)
        self.refreshRateHBox.set_border_width(2)
        self.refreshRateHBox.pack_start(self.refreshRateLabel, gtk.FALSE, gtk.FALSE)
        self.refreshRateHBox.pack_start(self.refreshRateSpin, gtk.FALSE, gtk.FALSE)
        self.refreshRateHBox.pack_start(self.refreshRateSecLabel, gtk.FALSE, gtk.FALSE)

        self.refreshRateFrame.add(self.refreshRateHBox)

        self.logFilesVBox = gtk.VBox(gtk.FALSE,2)
        self.logFilesVBox.pack_start(self.logFilesFrame, gtk.TRUE, gtk.TRUE)
        self.logFilesVBox.pack_start(self.refreshRateFrame, gtk.FALSE, gtk.FALSE)        
        self.prefsNotebook.append_page(self.logFilesVBox, gtk.Label(_("Log Files")))

	#--------Alert Icon page---------------------------------------------
        self.alertsVBox = gtk.VBox(gtk.FALSE, 2)
        self.alertsVBox.set_border_width(6)
        self.alertsFrame = gtk.Frame(_("Alerts"))
        self.alertsFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.alertsFrame.set_border_width(6)

        self.alertsDescriptionHBox = gtk.HBox(gtk.FALSE, 6)
        self.alertsDescriptionHBox.set_border_width(2)

        icon = None
        try:
            icon = gtk.gdk.pixbuf_new_from_file("/usr/share/redhat-logviewer/pixmaps/alert-big.png")
        except:
            pass

        image = gtk.Image()
        if icon:
            image.set_from_pixbuf(icon)

        self.alertsDescriptionHBox.pack_start(image)

        label = gtk.Label(_("Show alert icon for the following key words."))
        label.set_line_wrap(gtk.TRUE)
        label.set_size_request(250, -1)
        self.alertsDescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)

        self.alertsVBox.pack_start(self.alertsDescriptionHBox, gtk.FALSE, gtk.FALSE)

        #list store that contains key words to alert
        self.alertsListStore = gtk.ListStore(gobject.TYPE_STRING)
        for word in LogViewerGui.alertWords:
            #insert word into liststore
            if word != "":
                iter = self.alertsListStore.append()
                self.alertsListStore.set_value(iter, 0, string.strip(word))

	self.alertsTreeView = gtk.TreeView(self.alertsListStore)
        col = gtk.TreeViewColumn(None, gtk.CellRendererText(), text=0)
        col.set_visible(gtk.TRUE)
        self.alertsTreeView.set_headers_visible(gtk.FALSE)
        self.alertsTreeView.append_column(col)
        self.alertsTreeView.set_border_width(8)
        selection = self.alertsTreeView.get_selection()
##        selection.connect("changed", self.some_function)

        self.alertsHBox = gtk.HBox(gtk.FALSE)
        
        self.alertsTreeView.set_rules_hint(gtk.TRUE)
        self.alertsScrollWindow = gtk.ScrolledWindow()
        self.alertsScrollWindow.set_policy (POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        self.alertsScrollWindow.set_shadow_type(gtk.SHADOW_ETCHED_IN)

        self.alertsScrollWindow.add(self.alertsTreeView)
        self.alertsHBox.pack_start(self.alertsScrollWindow, gtk.TRUE, gtk.TRUE)

        self.alertsButtonVBox = gtk.VBox(gtk.FALSE,2)
        self.alertsAddButton = gtk.Button(_("Add"))
        self.alertsAddButton.connect ("clicked", self.on_add_alert)
        self.alertsDeleteButton = gtk.Button(_("Delete"))
        self.alertsDeleteButton.connect ("clicked", self.on_delete_alert)
        self.alertsButtonVBox.pack_start(self.alertsAddButton, gtk.FALSE, gtk.FALSE)
        self.alertsButtonVBox.pack_start(self.alertsDeleteButton, gtk.FALSE, gtk.FALSE)
        self.alertsHBox.pack_start(self.alertsButtonVBox)

        self.alertsVBox.pack_start(self.alertsHBox)
        self.alertsFrame.add(self.alertsVBox)

        self.prefsNotebook.append_page(self.alertsFrame, gtk.Label(_("Alerts")))
        

	#--------Display Properties page-------------------------------------
##         self.displayPropsVBox = gtk.VBox(gtk.FALSE, 6)
##         self.displayPropsFrame = gtk.Frame(_("Display Properties"))
##         self.displayPropsFrame.set_shadow_type(gtk.SHADOW_ETCHED_IN)
##         self.displayPropsFrame.set_border_width(6)        

##         self.dPdescriptionHBox = gtk.HBox(gtk.FALSE, 6)
##         self.dPdescriptionHBox.set_border_width(2)

##         prefsImage = gtk.Image()
##         prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 3)

##         self.dPdescriptionHBox.pack_start(prefsImage)

##         label = gtk.Label(_("For files that contain time stamps, log messages before the selected date will not be displayed. [not yet implemented] The currently-viewed log file will automatically refresh according the refresh rate."))
##         label.set_line_wrap(gtk.TRUE)
##         label.set_size_request(250, -1)
##         self.dPdescriptionHBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)
##         self.displayPropsVBox.pack_start(self.dPdescriptionHBox, gtk.FALSE, gtk.FALSE)

##         self.displayPropsFrame.add(self.displayPropsVBox)

##         self.refreshRateLabel = gtk.Label("Refresh Rate: ")
##         self.refreshRateSpin = gtk.SpinButton(gtk.Adjustment(LogViewerGui.RefreshRate/1000,30,600,1,1,0), 0, 0)
##         self.refreshRateSecLabel = gtk.Label("seconds")
##         self.refreshRateHBox = gtk.HBox(gtk.FALSE,3)
##         self.refreshRateHBox.set_border_width(2)
##         self.refreshRateHBox.pack_start(self.refreshRateLabel, gtk.FALSE, gtk.FALSE)
##         self.refreshRateHBox.pack_start(self.refreshRateSpin, gtk.FALSE, gtk.FALSE)
##         self.refreshRateHBox.pack_start(self.refreshRateSecLabel, gtk.FALSE, gtk.FALSE)
##         self.displayPropsVBox.pack_start(self.refreshRateHBox, gtk.FALSE, gtk.FALSE)
        
##         self.prefsNotebook.append_page(self.displayPropsFrame, gtk.Label(_("Display Properties")))

        
        #--------Buttons-------------------------------------------
        self.preferences.add_button("gtk-close", 0)

        #--------Show Dialog---------------------------------------
        self.preferences.show_all()

## Save Preferences and exit preferences Dialog

    def on_ok_clicked(self, *args):
        #write refresh rate to prefs file
        rr = self.refreshRateSpin.get_value()
        self.update_pref("REFRESHRATE", rr)
#        #write show-after date to prefs file
#        newDate = self.calendar.get_date()
#        date = str(newDate[1] + 1) + "," + str(newDate[2]) + "," + str(newDate[0]) + "," + "0" + "," + "0"
#        currentTime = time.strftime("%Y-%m-%d %H:%M:%S",time.localtime(time.time()))
#        self.update_pref("SHOWDATE", date)
        #write log file location prefs to prefs file
        for key in LogViewerGui.logDict.keys():
            self.update_pref(key, LogViewerGui.logDict[key])
        #hide prefs window
        self.preferences.hide()

## Close Preferences Dialog

    def on_cancel_clicked(self, *args):
        self.preferences.hide()

## Change Log File Location

    def on_changed_clicked(self, *args):
        #grab log file locations
        data, self.iter = self.logFilesTreeView.get_selection().get_selected()
        if self.iter == None:
            selectDialog = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, _("Please select a log file from the list."))
            selectDialog.set_title(_("Preferences"))
            selectDialog.set_default_size(100, 100)
            selectDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
            selectDialog.set_border_width(2)
            selectDialog.set_icon(LogViewerGui.iconPixbuf)
            selectDialog.set_modal(gtk.TRUE)
            selectDialog.set_transient_for(self.preferences)
            rc = selectDialog.run()
            if rc == gtk.RESPONSE_OK:
                selectDialog.hide()
            return

        self.changeLocationDialog = gtk.Dialog(_("Log File Locations"))
        self.changeLocationDialog.set_size_request(350, 150)
        self.changeLocationDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
        self.changeLocationDialog.set_border_width(2)
        self.changeLocationDialog.set_modal(gtk.TRUE)
        self.changeLocationDialog.set_transient_for(self.preferences)
        self.changeLocationDialog.set_icon(LogViewerGui.iconPixbuf)
        self.changeLocationDialog.add_button("gtk-cancel", 1)
        self.changeLocationDialog.add_button("gtk-ok", 0)
        clLabel = gtk.Label(_("Please enter a new location for the " + LogViewerGui.logFilesListStore.get_value(self.iter, 0)+ " file."))
        clLabel.set_line_wrap(gtk.TRUE)
        clLabel.set_size_request(300, -1)
        logFileHBox = gtk.HBox(gtk.FALSE, 6)

        prefsImage = gtk.Image()
        prefsImage.set_from_stock(gtk.STOCK_PREFERENCES, 3)

        # Change file location dialog
        logFileHBox.pack_start(prefsImage, gtk.FALSE, gtk.FALSE)
        logFileHBox.pack_start(clLabel, gtk.TRUE, gtk.TRUE, 6)
        self.logFileLocationLabel = gtk.Label(_("Location: "))
        self.logFileLocationEntry = gtk.Entry()
        self.logFileLocationEntry.set_text(LogViewerGui.logFilesListStore.get_value(self.iter, 1))
        self.logFileLocationEntry.connect ("activate", self.set_location)
        logFileLocationButton = gtk.Button(_("Browse..."))
        logFileLocationButton.connect("clicked", self.on_browse_clicked)
        logFileLocationHBox = gtk.HBox(gtk.FALSE, 6)
        logFileLocationHBox.pack_start(self.logFileLocationLabel, gtk.FALSE)
        logFileLocationHBox.pack_start(self.logFileLocationEntry, gtk.TRUE)
        logFileLocationHBox.pack_start(logFileLocationButton, gtk.FALSE, gtk.FALSE)
        self.changeLocationDialog.vbox.pack_start(logFileHBox, gtk.TRUE)
        self.changeLocationDialog.vbox.pack_start(logFileLocationHBox, gtk.TRUE, gtk.FALSE)
        
        self.changeLocationDialog.show_all()
        rc = self.changeLocationDialog.run()
        if rc == 0:
            logFileLocation = string.strip(self.logFileLocationEntry.get_text())
            #update list store with new location
            LogViewerGui.logFilesListStore.set_value(self.iter, 1, logFileLocation)
            #update list store boolean that location has changed
            LogViewerGui.logFilesListStore.set_value(self.iter, 3, 1)
            #update pref file
            self.update_pref(LogViewerGui.logFilesListStore.get_value(self.iter, 2), logFileLocation)
            self.changeLocationDialog.hide()
        elif rc == 1:
            self.changeLocationDialog.hide()

    def set_location(self, args):
        logFileLocation = string.strip(self.logFileLocationEntry.get_text())
        #update list store with new location
        LogViewerGui.logFilesListStore.set_value(self.iter, 1, logFileLocation)
        #update list store boolean that location has changed
        LogViewerGui.logFilesListStore.set_value(self.iter, 3, 1)
        #update pref file
        self.update_pref(LogViewerGui.logFilesListStore.get_value(self.iter, 2), logFileLocation)
        self.changeLocationDialog.hide()

## Browse for new log file location

    def on_browse_clicked(self, *args):
        ## not finished
        self.logFileSelection = gtk.FileSelection(_("Select Log File"))
        self.logFileSelection.set_filename("/var/")
        self.logFileSelection.ok_button.connect("clicked", self.on_ok_file_selected)
        self.logFileSelection.cancel_button.connect("clicked", self.on_cancel_file_selected)
        self.logFileSelection.connect("delete_event", self.on_cancel_file_selected)
        self.logFileSelection.set_modal(gtk.TRUE)
        self.logFileSelection.set_transient_for(self.preferences)
        self.logFileSelection.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.logFileSelection.show()

## Click ok in file selection dialog
        
    def on_ok_file_selected(self, *args):
        self.logFileLocationEntry.set_text(string.strip(self.logFileSelection.get_filename()))
        self.logFileSelection.hide()

## Click cancel in file selection dialog

    def on_cancel_file_selected(self, *args):
        self.logFileSelection.hide()

## Select Category for TreeView

    def select_category(self, object):
        model, iter = object.get_selected()
        data = model.get_value(iter, 0)

## Called by LogViewerGui to show Preferences Dialog

    def launch(self):
        return self.preferences
    
## Update preferences

    def update_pref(self, pref, value):
        #update value currently being used
        if pref == "ALERTWORDS":
            pass
        elif pref == "REFRESHRATE":
            LogViewerGui.RefreshRate = int(value)*1000
            if LogViewerGui.RefreshRate < 30000:
                LogViewerGui.RefreshRate = 30000
##         elif pref == "SHOWDATE":
##             LogViewerGui.month,LogViewerGui.day,LogViewerGui.year,LogViewerGui.hour,LogViewerGui.minute = string.split(value,",")
##             LogViewerGui.month = string.strip(LogViewerGui.month)
##             LogViewerGui.day = string.strip(LogViewerGui.day)
##             LogViewerGui.year = string.strip(LogViewerGui.year)
##             LogViewerGui.hour = string.strip(LogViewerGui.hour)
##             LogViewerGui.minute = string.strip(LogViewerGui.minute)
        else:
            #log file location preference
            LogViewerGui.logDict[pref] = value
        # FIXME: auto_refresh if location changes
        ##LogViewerGui.auto_refresh()
            
        #read in prefs file
        try:
            prefsFile = open("/etc/sysconfig/redhat-logviewer", "r")
            prefsLines = prefsFile.readlines()
            prefsFile.close()
        except:
            #FIXME: show message dialog that says can't open pref file, same as in LogViewerGui
            print "Preferences file not found."

        #update prefs
        found = 0
        count = 0
        for line in prefsLines:
            line = string.strip(line)
            if line != "" and line[0]!="#":
                preference, oldvalue = string.split(line,"=")
                preference = string.strip(preference)
                #handle alert words
                if preference == "ALERTWORDS" and pref == "REMALERTWORDS":
                    newAlertWords = "ALERTWORDS="
                    length = len(LogViewerGui.alertWords)
                    for word in LogViewerGui.alertWords:
                        if length == 1:
                            newAlertWords = newAlertWords + word
                        else:
                            newAlertWords = newAlertWords + word + ","
                        length = length - 1
                    prefsLines[count] = newAlertWords
                elif preference == pref:
                    if pref == "REFRESHRATE":
                        prefsLines[count] = string.replace(line, oldvalue, str(int(value)) + "\n")
                    elif pref == "ALERTWORDS":
                        prefsLines[count] = line + "," + value
##                     elif pref == "SHOWDATE":
##                         newvalue = LogViewerGui.month + "," + LogViewerGui.day + "," + LogViewerGui.year + "," + LogViewerGui.hour + "," + LogViewerGui.minute + "\n"
##                         prefsLines[count] = string.replace(line, oldvalue, newvalue)
                    else:
                        #log file location preference
                        prefsLines[count] = string.replace(line, oldvalue, str(LogViewerGui.logDict[pref] + "\n"))
            count = count + 1

        #write prefs back
        os.rename("/etc/sysconfig/redhat-logviewer", "/etc/sysconfig/redhat-logviewer.bak")
        try:
            prefsFile = open("/etc/sysconfig/redhat-logviewer", "w")
            for line in prefsLines:
                prefsFile.write(line)
            prefsFile.close()
        except:
            #FIXME: show message dialog that says can't write to pref file
            print "Error writing prefs file."

## Add alert keyword

    def on_add_alert (self, *args):
        self.addAlertsDialog = gtk.Dialog(_("Add Alert Word"))
        self.addAlertsDialog.set_default_size(100, 100)
        self.addAlertsDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
        self.addAlertsDialog.set_border_width(2)
        self.addAlertsDialog.set_modal(gtk.TRUE)
        self.addAlertsDialog.set_transient_for(self.preferences)
        self.addAlertsDialog.set_icon(LogViewerGui.iconPixbuf)
        self.addAlertsDialog.set_has_separator(gtk.FALSE)
        label = gtk.Label(_("Enter a word to add to the list of alert words."))
        addAlertsVBox = gtk.VBox(gtk.FALSE, 6)
        addAlertsVBox.pack_start(label, gtk.TRUE, gtk.TRUE, 6)
        self.alertsEntry = gtk.Entry()
        self.alertsEntry.connect ("activate", self.add_alert)



        alertsCancelButton = self.addAlertsDialog.add_button('gtk-cancel', 0)
        alertsCancelButton.connect ("clicked", self.on_cancel_alert)        
                                          
        alertsOKButton = self.addAlertsDialog.add_button('gtk-ok', 0)
        alertsOKButton.connect ("clicked", self.add_alert)
                                         
        addAlertsVBox.pack_start(self.alertsEntry, gtk.TRUE, gtk.TRUE, 6)

        self.addAlertsDialog.vbox.pack_start(addAlertsVBox, gtk.TRUE)
        self.addAlertsDialog.show_all()

    def on_cancel_alert(self, *args):
        self.addAlertsDialog.destroy()
        
    def add_alert(self, *args):
        #FIXME -- check for null string
        alert = string.strip(self.alertsEntry.get_text())
        if alert != "":
            #add to liststore
            iter = self.alertsListStore.append()
            self.alertsListStore.set_value(iter, 0, alert)
            #add to alertWords
            LogViewerGui.alertWords.append(alert)
            #add to prefs file
            self.update_pref("ALERTWORDS", alert)
            #hide dialog
            self.addAlertsDialog.hide()
        else:
            noAlertWordDialog = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, _("Please specify an alert word to add."))
            noAlertWordDialog.set_title(_("Alerts"))
            noAlertWordDialog.set_default_size(100, 100)
            noAlertWordDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
            noAlertWordDialog.set_border_width(2)
            noAlertWordDialog.set_modal(gtk.TRUE)
            noAlertWordDialog.set_transient_for(self.addAlertsDialog)
            noAlertWordDialog.set_icon(LogViewerGui.iconPixbuf)
            rc = noAlertWordDialog.run()
            if rc == gtk.RESPONSE_OK:
                noAlertWordDialog.hide()
            return

## Delete alert keyword

    def on_delete_alert (self, *args):
        #grab selected alert word
        data, iter = self.alertsTreeView.get_selection().get_selected()
        if iter == None:
            selectDialog = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, _("Please select an alert word from the list."))
            selectDialog.set_title(_("Alerts"))
            selectDialog.set_default_size(100, 100)
            selectDialog.set_position (gtk.WIN_POS_CENTER_ON_PARENT)
            selectDialog.set_border_width(2)
            selectDialog.set_modal(gtk.TRUE)
            selectDialog.set_transient_for(self.preferences)
            selectDialog.set_icon(LogViewerGui.iconPixbuf)
            rc = selectDialog.run()
            if rc == gtk.RESPONSE_OK:
                selectDialog.hide()
            return

        alert = data.get_value(iter, 0)
        #delete from ListStore to delete from TreeView
        data.remove(iter)
        #delete from alertWords
        LogViewerGui.alertWords.remove(alert)
        #delete from prefs file
        self.update_pref("REMALERTWORDS", alert)
        

##---------------------------------------------------------------
##--------------------------------------------------------------
